## HyFeeTools
Dieses Repo enthält nützliche Skripte für die Verwendung von [HyFee](https://hyfee.de/) von Christian Mayr mit einer Nextcloud.

### Übersicht
#### HyFee Vorab-Code-Generator
Der Generator kann genutzt werden, um eine beliebige Anzahl an Platzhalter-Codes für HyFee in einer Nextcloud zu generieren.

```python main.py```

### Installation
0. Abhängigkeiten installieren: ```pip install qrcode --user```
1. Git Repo clonen: ```git clone https://dev.spittank.org/daniel/HyFeeTools.git```
2. Nextcloud-API-Wrapper installieren:
   ```bash
    git submodule init
    cd nextcloud-API
    python setup.py build
    python setup.py install --user
    ```
3. Konfigurationsbeispiel ```config.json.example``` nach ```config.json``` kopieren und Einstellungen anpassen.

### Verwendung
Der Generator kann direkt aufgerufen werden und verarbeitet die folgenden optionalen Kommandozeilenargumente:

- ```-n NUMBER``` oder ```--number NUMBER``` für die Anzahl der zu erstellenden Platzhalter.
- ```-t TYP``` oder ```--type TYP``` für den Typ der zu erstellenden Platzhalter (audio, image, pdf, video, dir).
- ```-s SUBJECT``` oder ```--subject SUBJECT``` für einen frei zu wählenden Bezeichner, der statt der Uhrzeit im Dateinamen der Platzhalter verwendet wird.
- ```--qr``` für die Ausgabe von QR-Codes als Einzelbilder. 

Der Generator gibt immer eine CSV-Datei der erstellten Codes aus. Diese befindet sich standardmäßig im Verzeichnis des Skripts und hat den Namen der Serie, i.d.R. also Datum und Uhrzeit der Generierung. Diese kann z.B. für den Seriendruck verwendet werden.

Folgendes Beispiel legt zwei Videoplatzhalter an und gibt QR-Codes dafür aus.

```bash
./generator.py -n 2 -t video --qr
```

### Verwendete Bibliotheken
Der Generator greift für die Verbindung zu Nextcloud auf den [nextcloud-api-wrapper von luffah](https://github.com/luffah/nextcloud-API). Es wird allerdings eine Developement-Version von [MrCapsLock](https://github.com/MrCapsLock/nextcloud-API/tree/develop) verwendet, da der entsprechende Pullrequest bisher nicht angenommen wurde.

Die geänderte Version ist notwendig, um die Anzeige eines Downloadlinks zu deaktivieren. Das Paket ist diesem Repo als Submodul hinzugefügt. Um das Paket zu installieren kann wie folgt vorgegangen werden (Linux / mac OS):

```bash
git submodule init
cd nextcloud-API
python setup.py build
python setup.py install --user
```
Außerdem verwendet der Generator das Paket qrcode. Zur Installation kann PIP verwendet werden: ```pip install qrcode --user```
